#***************************************************************************
#                       Font-Editor
#                       ===========
#                     Uwe Berger; 2009
#
#
# Generierung von Zeichenfonts. Der einzubindende Tcl-Code landet im 
# System-Clipboard...
#
# ---------
# Have fun!
#
#***************************************************************************


#**** einige Variable ****
set gvar(dx) 5; 								# x-Dimension				
set gvar(dy) 7;									# y-Dimension
set gvar(raster) 14;							# Abstand der Punkte untereinander
set gvar(led_radius) [expr $gvar(raster) / 2];	# Durchmesser ;-) der LEDs
set gvar(led) {};								# LED-Feld (wird spaeter initialisiert)

#*************************
proc gui_init {} {
	global gvar
	wm title . "Font-Editor" 

	frame .f1
	canvas	.f1.matrix -width [expr ($gvar(dx) + 1) * $gvar(raster) + $gvar(raster) / 2] \
			-height [expr ($gvar(dy) + 1) * $gvar(raster) + $gvar(raster) / 2] \
			-bg black -bd 0
	pack .f1 -fill both -side left
	pack .f1.matrix 

	frame .f2

	pack .f2 -side left
	for {set y 0} {$y<$gvar(dy)} {incr y} {
		for {set x 0} {$x<$gvar(dx)} {incr x} {
			checkbutton .f2.b$x$y -command draw_matrix -variable gvar(p$x$y)
			grid .f2.b$x$y -row $y -column $x
		}
	}

	frame .f1.f3
	label .f1.f3.l1 -text "sign"
	entry .f1.f3.e1 -textvariable gvar(sign) -width 3
	pack .f1.f3.l1 -side left
	pack .f1.f3.e1 -side left
	pack .f1.f3

	frame .f4
	button .f4.b1 -text "clear sign" -command clear_all
	button .f4.b2 -text "clear clipboard" -command {clipboard clear}
	button .f4.b3 -text "append to clipboard" -command {clipboard_fill}
	pack .f4.b1 -fill both
	pack .f4.b2 -fill both
	pack .f4.b3 -fill both
	pack .f4
}

#*************************
proc clipboard_fill {} {
	global gvar
	#clipboard clear
	clipboard append "\t$gvar(sign)\t\t\{\n\t\t\t"
	for {set y 0} {$y < $gvar(dy)} {incr y} {
		for {set x 0} {$x < $gvar(dx)} {incr x} {
			clipboard append " $gvar(p$x$y)"
		}
		clipboard append "\\\n\t\t\t"
	}	
	clipboard append "\}\n"
}

#*************************
proc draw_matrix {} {
	global gvar
	.f1.matrix delete all
	for {set y 0} {$y < $gvar(dy)} {incr y} {
		for {set x 0} {$x < $gvar(dx)} {incr x} {
			if {$gvar(p$x$y) > 0} {
				set color red
			} else {
				set color gray5
			}
			.f1.matrix create oval	[expr $gvar(raster)  * ($x + 1)] \
						[expr $gvar(raster)  * ($y + 1)] \
						[expr ($gvar(raster) * ($x + 1)) + $gvar(led_radius)] \
						[expr ($gvar(raster) * ($y + 1)) + $gvar(led_radius)] \
						-outline $color -fill $color
		}
	}
	update
}

#*************************
proc clear_all {} {
	global gvar
	for {set y 0} {$y < $gvar(dy)} {incr y} {
		for {set x 0} {$x < $gvar(dx)} {incr x} {
			set gvar(p$x$y) 0
		}
	}	
	draw_matrix
}


#********************** Main *********************************
gui_init
draw_matrix


